# NEARNEIGHBOR

NAME
SYNOPSIS
DESCRIPTION
OPTIONS
EXAMPLES
SEE ALSO

## NAME

| nearneighbor − A "Nearest neighbor" gridding algorithm

## SYNOPSIS

| nearneighbor [ xyzfile(s) ] −G out_grdfile −I xinc[unit][=|+][/yinc[unit][=|+]] −N sectors −R west/east/south/north[r] −S search_radius[m|c|k|K] [ −E empty ] [ −F ] [ −H[i][nrec] ] [ −L flag ] [ −V ] [ −W ] [ −:[i|o] ] [ −bi[s|S|d|D][ncol] ] [ −f colinfo ]

## DESCRIPTION

nearneighbor reads arbitrarily located (x,y,z[,w]) triples [quadruplets] from standard input [or xyzfile(s)] and uses a nearest neighbor algorithm to assign an average value to each node that have one or more points within a radius centered on the node. The average value is computed as a weighted mean of the nearest point from each sector inside the search radius. The weighting function used is w(r) = 1 / (1 + d ^ 2), where d = 3 * r / search_radius and r is distance from the node. This weight is modulated by the observation points’ weights [if supplied].

| xyzfile(s)

| 3 [or 4, see −W] column ASCII file(s) [or binary, see −b] holding (x,y,z[,w]) data values. If no file is specified, nearneighbor will read from standard input.

| −G |  | Give the name of the output grdfile.

−I

x_inc [and optionally y_inc] is the grid spacing. Append m to indicate minutes or c to indicate seconds. If one of the units e, k, i, or n is appended instead, the increment will be assumed to be in meter, km, miles, or nautical miles, respectively, and will be converted to the equivalent degrees longitude at the middle latitude of the region (the conversion depends on ELLIPSOID). If /y_inc is given but set to 0 it will be reset equal to x_inc; otherwise it will be converted to degrees latitude. If = is appended then the corresponding max x (east) or y (north) may be slightly adjusted to fit exactly the given increment [by default the increment may be adjusted slightly to fit the given domain]. Finally, instead of giving an increment you may specify the number of nodes desired by appending + to the supplied increment; the increment is then recalculated from the number of nodes and the domain. The resulting increment value depends on whether you have selected a gridline-registered or pixel- registered grid; see Appendix B for details.

−N

The circular area centered on each node is divided into several sectors. Average values will only be computed if there is at least one value inside each of the sectors for a given node. Nodes that fail this test are assigned the value NaN (but see −E). [Default is quadrant search, i.e., sectors = 4]. Note that only the nearest value per sector enters into the averaging, not all values inside the circle.

−R

xmin, xmax, ymin, and ymax specify the Region of interest. For geographic regions, these limits correspond to west, east, south, and north and you may specify them in decimal degrees or in [+-]dd:mm[:ss.xxx][W|E|S|N] format. Append r if lower left and upper right map coordinates are given instead of wesn. The two shorthands −Rg −Rd stand for global domain (0/360 or -180/+180 in longitude respectively, with -90/+90 in latitude). For calendar time coordinates you may either give relative time (relative to the selected TIME_EPOCH and in the selected TIME_UNIT; append t to −JX|x), or absolute time of the form [date]T[clock] (append T to −JX|x). At least one of date and clock must be present; the T is always required. The date string must be of the form [-]yyyy[-mm[-dd]] (Gregorian calendar) or yyyy[-Www[-d]] (ISO week calendar), while the clock string must be of the form hh:mm:ss[.xxx]. The use of delimiters and their type and positions must be as indicated (however, input/output and plotting formats are flexible).

−S

Sets the search_radius in same units as the grid spacing; append m to indicate minutes or c to indicate seconds. Append k to indicate km (implies −R and −I are in degrees, and we will use a fast flat Earth approximation to calculate distance). For more accuracy, use uppercase K if distances should be calculated along geodesics. However, if the current ELLIPSOID is set to Sphere then spherical great circle calculations are used.

## OPTIONS

| −E |  | Set the value assigned to empty nodes [NaN].
| −F |  | Force pixel registration. [Default is grid registration].
| −H |  | Input file(s) has Header record(s). Number of header records can be changed by editing your .gmtdefaults4 file. If used, GMT default is 1 header record. Use −Hi if only input data should have header records [Default will write out header records if the input data have them]. Not used with binary data.
| −L |  | Boundary condition flag may be x or y or xy indicating data is periodic in range of x or y or both set by −R, or flag may be g indicating geographical conditions (x and y are lon and lat). [Default is no boundary conditions].
| −V |  | Selects verbose mode, which will send progress reports to stderr [Default runs "silently"].
| −: |  | Toggles between (longitude,latitude) and (latitude,longitude) input and/or output. [Default is (longitude,latitude)]. Append i to select input only or o to select output only. [Default affects both].
| −W |  | Input data have a 4th column containing observation point weights. These are multiplied with the geometrical weight factor to determine the actual weights used in the calculations.
| −bi |  | Selects binary input. Append s for single precision [Default is d (double)]. Uppercase S (or D) will force byte-swapping. Optionally, append ncol, the number of columns in your binary file if it exceeds the columns needed by the program. [Default is 3 (or 4 if −W is set) columns].

−f

Special formatting of input and output columns (time or geographical data). Specify i(nput) or o(utput) [Default is both input and output]. Give one or more columns (or column ranges) separated by commas. Append T (Absolute calendar time), t (time relative to chosen TIME_EPOCH), x (longitude), y (latitude), or f (floating point) to each column or column range item. Shorthand −f[i|o]g means −f[i|o]0x,1y (geographic coordinates).

## EXAMPLES

To create a gridded data set from the file seaMARCII_bathy.lon_lat_z using a 0.5 min grid, a 5 km search radius, using an octant search, and set empty nodes to -9999:

nearneighbor seaMARCII_bathy.lon_lat_z −R242/244/-22/-20 −I.5m −E-9999 −Gbathymetry.grd −S5k −N8

To make a global gridded file from the data in geoid.xyz using a 1 degree grid, a 200 km search radius, spherical distances, using an quadrant search, and set empty nodes to NaN, run

nearneighbor geoid.xyz −R0/360/-90/90 −I1 −Lg −Ggeoid.grd −S20K −N4

## SEE ALSO

| blockmean(l), blockmedian(l), blockmode(l), GMT(l), surface(l), triangulate(l)